#!/usr/bin/env python2
from __future__ import print_function

"""filesink.py: http upload target"""
__version__   = "1.0"
__author__    = "ed <filesink@ocv.me>"
__url__       = "https://ocv.me/dev/?filesink.py"
__credits__   = ["stackoverflow.com"]
__license__   = "MIT"
__copyright__ = 2019

# this is slow (32 MB/s) since it uses the built-in http parser,
# consider using filedrop.py which is 16 times faster:
#   https://ocv.me/dev/?filedrop.py


import shutil
import cgi
import time
try:
	from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer  # py2
except:
	from http.server import BaseHTTPRequestHandler, HTTPServer  # py3

class Srv(BaseHTTPRequestHandler):
	def do_POST(self):
		form = cgi.FieldStorage(
			fp=self.rfile,
			headers=self.headers,
			environ={
				"REQUEST_METHOD": "POST",
				"CONTENT_TYPE": "application/octet-stream"
			}
		)
		
		fname = 'inc.{0:.3f}'.format(time.time())
		print('writing file {0}'.format(fname))
		with open(fname, 'wb') as f:
			shutil.copyfileobj(form['f'].file, f)

		self.wfile.write(b'HTTP/1.1 200 OK\r\nContent-Length: 3\r\n\r\nok!')
		print('ok')

	def do_GET(self):
		msg = b'<form method="post" enctype="multipart/form-data"><h5><input type="file" name="f"><h5><input type="submit">'
		self.wfile.write(b'HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nContent-Length: {}\r\n\r\n'.format(len(msg)))
		self.wfile.write(msg)

port = 1234
print('listening on port', port)
HTTPServer(('0.0.0.0', port), Srv).serve_forever()

